blob: 2f47e065fe8b7ca856f4527d6a507a28f1b2a06b [file] [log] [blame]
Lars Hjemli70c7ac22007-05-26 15:56:40 +02001#!/bin/sh
2#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +02003# git-submodules.sh: add, init, update or list git submodules
Lars Hjemli70c7ac22007-05-26 15:56:40 +02004#
5# Copyright (c) 2007 Lars Hjemli
6
Ping Yinf2dc06a2008-03-11 21:52:17 +08007USAGE="[--quiet] [--cached] \
Mark Levedahlec05df32008-07-09 21:05:40 -04008[add <repo> [-b branch] <path>]|[status|init|update [-i|--init]|summary [-n|--summary-limit <n>] [<commit>]] \
David Aguilar2327f612008-08-24 12:43:37 -07009[--] [<path>...]|[foreach <command>]|[sync [--] [<path>...]]"
Junio C Hamano8f321a32007-11-06 01:50:02 -080010OPTIONS_SPEC=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020011. git-sh-setup
Mark Levedahl98fcf842008-08-24 14:46:10 -040012. git-parse-remote
Lars Hjemli70c7ac22007-05-26 15:56:40 +020013require_work_tree
14
Junio C Hamano5c08dbb2008-01-15 02:48:45 -080015command=
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020016branch=
Lars Hjemli70c7ac22007-05-26 15:56:40 +020017quiet=
18cached=
19
20#
21# print stuff on stdout unless -q was specified
22#
23say()
24{
25 if test -z "$quiet"
26 then
27 echo "$@"
28 fi
29}
30
Mark Levedahlf31a5222007-09-23 22:19:42 -040031# Resolve relative url by appending to parent's url
32resolve_relative_url ()
33{
Mark Levedahl98fcf842008-08-24 14:46:10 -040034 remote=$(get_default_remote)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -040035 remoteurl=$(git config "remote.$remote.url") ||
36 die "remote ($remote) does not have a url defined in .git/config"
Mark Levedahlf31a5222007-09-23 22:19:42 -040037 url="$1"
Mark Levedahl99b120a2008-08-21 19:54:01 -040038 remoteurl=${remoteurl%/}
Mark Levedahlf31a5222007-09-23 22:19:42 -040039 while test -n "$url"
40 do
41 case "$url" in
42 ../*)
43 url="${url#../}"
44 remoteurl="${remoteurl%/*}"
45 ;;
46 ./*)
47 url="${url#./}"
48 ;;
49 *)
50 break;;
51 esac
52 done
Mark Levedahl99b120a2008-08-21 19:54:01 -040053 echo "$remoteurl/${url%/}"
Mark Levedahlf31a5222007-09-23 22:19:42 -040054}
55
Lars Hjemli941987a2007-06-11 21:12:24 +020056#
David Aguilara7b32692008-08-22 00:30:50 -070057# Get submodule info for registered submodules
58# $@ = path to limit submodule list
59#
60module_list()
61{
62 git ls-files --stage -- "$@" | grep '^160000 '
63}
64
65#
Lars Hjemli941987a2007-06-11 21:12:24 +020066# Map submodule path to submodule name
67#
68# $1 = path
69#
70module_name()
71{
Junio C Hamano537601a2007-07-25 15:51:26 -070072 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
Chris Riddfe22e542008-06-11 14:09:19 +010073 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
Imran M Yousufa5099bb2008-05-15 13:42:58 +060074 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
Junio C Hamano537601a2007-07-25 15:51:26 -070075 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
Lars Hjemli941987a2007-06-11 21:12:24 +020076 test -z "$name" &&
77 die "No submodule mapping found in .gitmodules for path '$path'"
78 echo "$name"
79}
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020080
81#
82# Clone a submodule
83#
Junio C Hamano23a485e2008-01-15 02:35:49 -080084# Prior to calling, cmd_update checks that a possibly existing
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020085# path is not a git repository.
Junio C Hamano23a485e2008-01-15 02:35:49 -080086# Likewise, cmd_add checks that path does not exist at all,
Sven Verdoolaegeecda0722007-06-24 23:06:07 +020087# since it is the location of a new submodule.
88#
Lars Hjemli33aa6ff2007-06-06 11:13:01 +020089module_clone()
90{
91 path=$1
92 url=$2
93
94 # If there already is a directory at the submodule path,
95 # expect it to be empty (since that is the default checkout
96 # action) and try to remove it.
97 # Note: if $path is a symlink to a directory the test will
98 # succeed but the rmdir will fail. We might want to fix this.
99 if test -d "$path"
100 then
101 rmdir "$path" 2>/dev/null ||
102 die "Directory '$path' exist, but is neither empty nor a git repository"
103 fi
104
105 test -e "$path" &&
106 die "A file already exist at path '$path'"
107
108 git-clone -n "$url" "$path" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200109 die "Clone of '$url' into submodule path '$path' failed"
Lars Hjemli33aa6ff2007-06-06 11:13:01 +0200110}
111
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200112#
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200113# Add a new submodule to the working tree, .gitmodules and the index
114#
Mark Levedahlec05df32008-07-09 21:05:40 -0400115# $@ = repo path
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200116#
117# optional branch is stored in global branch variable
118#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800119cmd_add()
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200120{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800121 # parse $args after "submodule ... add".
122 while test $# -ne 0
123 do
124 case "$1" in
125 -b | --branch)
126 case "$2" in '') usage ;; esac
127 branch=$2
128 shift
129 ;;
130 -q|--quiet)
131 quiet=1
132 ;;
133 --)
134 shift
135 break
136 ;;
137 -*)
138 usage
139 ;;
140 *)
141 break
142 ;;
143 esac
144 shift
145 done
146
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200147 repo=$1
148 path=$2
149
Mark Levedahlec05df32008-07-09 21:05:40 -0400150 if test -z "$repo" -o -z "$path"; then
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200151 usage
152 fi
153
Mark Levedahlec05df32008-07-09 21:05:40 -0400154 # assure repo is absolute or relative to parent
155 case "$repo" in
156 ./*|../*)
157 # dereference source url relative to parent's url
158 realrepo=$(resolve_relative_url "$repo") || exit
159 ;;
160 *:*|/*)
161 # absolute url
162 realrepo=$repo
163 ;;
164 *)
165 die "repo URL: '$repo' must be absolute or begin with ./|../"
166 ;;
167 esac
168
169 # strip trailing slashes from path
170 path=$(echo "$path" | sed -e 's|/*$||')
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200171
Junio C Hamano5be60072007-07-02 22:52:14 -0700172 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200173 die "'$path' already exists in the index"
174
Mark Levedahld4264ca2008-03-04 20:15:02 -0500175 # perhaps the path exists and is already a git repo, else clone it
176 if test -e "$path"
177 then
Mark Levedahle9656472008-07-07 22:36:40 -0400178 if test -d "$path"/.git -o -f "$path"/.git
Mark Levedahld4264ca2008-03-04 20:15:02 -0500179 then
180 echo "Adding existing repo at '$path' to the index"
181 else
182 die "'$path' already exists and is not a valid git repo"
183 fi
Mark Levedahlc2f93912008-07-09 21:05:41 -0400184
185 case "$repo" in
186 ./*|../*)
187 url=$(resolve_relative_url "$repo") || exit
188 ;;
189 *)
190 url="$repo"
191 ;;
192 esac
193 git config submodule."$path".url "$url"
Mark Levedahld4264ca2008-03-04 20:15:02 -0500194 else
Mark Levedahld4264ca2008-03-04 20:15:02 -0500195
196 module_clone "$path" "$realrepo" || exit
Ping Yinb9b378a2008-09-26 23:33:23 +0800197 (unset GIT_DIR; cd "$path" && git checkout -f -q ${branch:+-b "$branch" "origin/$branch"}) ||
Mark Levedahld4264ca2008-03-04 20:15:02 -0500198 die "Unable to checkout submodule '$path'"
199 fi
200
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200201 git add "$path" ||
202 die "Failed to add submodule '$path'"
203
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600204 git config -f .gitmodules submodule."$path".path "$path" &&
205 git config -f .gitmodules submodule."$path".url "$repo" &&
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200206 git add .gitmodules ||
207 die "Failed to register submodule '$path'"
208}
209
210#
Mark Levedahl19a31f92008-08-10 19:10:04 -0400211# Execute an arbitrary command sequence in each checked out
212# submodule
213#
214# $@ = command to execute
215#
216cmd_foreach()
217{
David Aguilara7b32692008-08-22 00:30:50 -0700218 module_list |
Mark Levedahl19a31f92008-08-10 19:10:04 -0400219 while read mode sha1 stage path
220 do
221 if test -e "$path"/.git
222 then
223 say "Entering '$path'"
224 (cd "$path" && eval "$@") ||
225 die "Stopping at '$path'; script returned non-zero status."
226 fi
227 done
228}
229
230#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200231# Register submodules in .git/config
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200232#
233# $@ = requested paths (default to all)
234#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800235cmd_init()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200236{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800237 # parse $args after "submodule ... init".
238 while test $# -ne 0
239 do
240 case "$1" in
241 -q|--quiet)
242 quiet=1
243 ;;
244 --)
245 shift
246 break
247 ;;
248 -*)
249 usage
250 ;;
251 *)
252 break
253 ;;
254 esac
255 shift
256 done
257
David Aguilara7b32692008-08-22 00:30:50 -0700258 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200259 while read mode sha1 stage path
260 do
Lars Hjemli211b7f12007-06-06 11:13:02 +0200261 # Skip already registered paths
Lars Hjemli941987a2007-06-11 21:12:24 +0200262 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700263 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200264 test -z "$url" || continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200265
Imran M Yousufa5099bb2008-05-15 13:42:58 +0600266 url=$(git config -f .gitmodules submodule."$name".url)
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200267 test -z "$url" &&
Lars Hjemli941987a2007-06-11 21:12:24 +0200268 die "No url found for submodule path '$path' in .gitmodules"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200269
Mark Levedahlf31a5222007-09-23 22:19:42 -0400270 # Possibly a url relative to parent
271 case "$url" in
272 ./*|../*)
Mark Levedahl8e7e6f32008-06-14 13:09:41 -0400273 url=$(resolve_relative_url "$url") || exit
Mark Levedahlf31a5222007-09-23 22:19:42 -0400274 ;;
275 esac
276
Junio C Hamano5be60072007-07-02 22:52:14 -0700277 git config submodule."$name".url "$url" ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200278 die "Failed to register url for submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200279
Lars Hjemli941987a2007-06-11 21:12:24 +0200280 say "Submodule '$name' ($url) registered for path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200281 done
282}
283
284#
Lars Hjemli211b7f12007-06-06 11:13:02 +0200285# Update each submodule path to correct revision, using clone and checkout as needed
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200286#
287# $@ = requested paths (default to all)
288#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800289cmd_update()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200290{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800291 # parse $args after "submodule ... update".
292 while test $# -ne 0
293 do
294 case "$1" in
295 -q|--quiet)
Pierre Habouzitd1f63a32008-07-21 20:15:59 +0200296 shift
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800297 quiet=1
298 ;;
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100299 -i|--init)
300 shift
301 cmd_init "$@" || return
302 ;;
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800303 --)
304 shift
305 break
306 ;;
307 -*)
308 usage
309 ;;
310 *)
311 break
312 ;;
313 esac
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800314 done
315
David Aguilara7b32692008-08-22 00:30:50 -0700316 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200317 while read mode sha1 stage path
318 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200319 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700320 url=$(git config submodule."$name".url)
Lars Hjemli211b7f12007-06-06 11:13:02 +0200321 if test -z "$url"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200322 then
323 # Only mention uninitialized submodules when its
324 # path have been specified
325 test "$#" != "0" &&
Alexandre Julliard989206f2008-11-11 22:09:16 +0100326 say "Submodule path '$path' not initialized" &&
Johannes Schindelinbe4d2c82008-05-16 11:23:03 +0100327 say "Maybe you want to use 'update --init'?"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200328 continue
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200329 fi
Lars Hjemli211b7f12007-06-06 11:13:02 +0200330
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100331 if ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli211b7f12007-06-06 11:13:02 +0200332 then
333 module_clone "$path" "$url" || exit
Lars Hjemlibf2d8242007-06-11 21:12:22 +0200334 subsha1=
335 else
H.Merijn Brand51884082007-12-04 22:45:16 +0000336 subsha1=$(unset GIT_DIR; cd "$path" &&
Junio C Hamano5be60072007-07-02 22:52:14 -0700337 git rev-parse --verify HEAD) ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200338 die "Unable to find current revision in submodule path '$path'"
Lars Hjemli211b7f12007-06-06 11:13:02 +0200339 fi
340
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200341 if test "$subsha1" != "$sha1"
342 then
Ping Yinb9b378a2008-09-26 23:33:23 +0800343 force=
344 if test -z "$subsha1"
345 then
346 force="-f"
347 fi
H.Merijn Brand51884082007-12-04 22:45:16 +0000348 (unset GIT_DIR; cd "$path" && git-fetch &&
Ping Yinb9b378a2008-09-26 23:33:23 +0800349 git-checkout $force -q "$sha1") ||
Lars Hjemli941987a2007-06-11 21:12:24 +0200350 die "Unable to checkout '$sha1' in submodule path '$path'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200351
Lars Hjemli941987a2007-06-11 21:12:24 +0200352 say "Submodule path '$path': checked out '$sha1'"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200353 fi
354 done
355}
356
Emil Medvebffe71f2007-06-26 18:40:58 -0500357set_name_rev () {
358 revname=$( (
H.Merijn Brand51884082007-12-04 22:45:16 +0000359 unset GIT_DIR
Emil Medvebffe71f2007-06-26 18:40:58 -0500360 cd "$1" && {
Junio C Hamano5be60072007-07-02 22:52:14 -0700361 git describe "$2" 2>/dev/null ||
362 git describe --tags "$2" 2>/dev/null ||
Mark Levedahlf669ac02008-04-14 22:48:06 -0400363 git describe --contains "$2" 2>/dev/null ||
364 git describe --all --always "$2"
Emil Medvebffe71f2007-06-26 18:40:58 -0500365 }
366 ) )
367 test -z "$revname" || revname=" ($revname)"
368}
Ping Yin28f9af52008-03-11 21:52:15 +0800369#
370# Show commit summary for submodules in index or working tree
371#
372# If '--cached' is given, show summary between index and given commit,
373# or between working tree and given commit
374#
375# $@ = [commit (default 'HEAD'),] requested paths (default all)
376#
377cmd_summary() {
Ping Yinf2dc06a2008-03-11 21:52:17 +0800378 summary_limit=-1
Ping Yind0f64dd2008-04-12 23:05:31 +0800379 for_status=
Emil Medvebffe71f2007-06-26 18:40:58 -0500380
Ping Yin28f9af52008-03-11 21:52:15 +0800381 # parse $args after "submodule ... summary".
382 while test $# -ne 0
383 do
384 case "$1" in
385 --cached)
386 cached="$1"
387 ;;
Ping Yind0f64dd2008-04-12 23:05:31 +0800388 --for-status)
389 for_status="$1"
390 ;;
Ping Yinf2dc06a2008-03-11 21:52:17 +0800391 -n|--summary-limit)
392 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
393 then
394 :
395 else
396 usage
397 fi
398 shift
399 ;;
Ping Yin28f9af52008-03-11 21:52:15 +0800400 --)
401 shift
402 break
403 ;;
404 -*)
405 usage
406 ;;
407 *)
408 break
409 ;;
410 esac
411 shift
412 done
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200413
Ping Yinf2dc06a2008-03-11 21:52:17 +0800414 test $summary_limit = 0 && return
415
Miklos Vajna30353a42008-12-03 14:26:52 +0100416 if rev=$(git rev-parse -q --verify "$1^0")
Ping Yin28f9af52008-03-11 21:52:15 +0800417 then
418 head=$rev
419 shift
420 else
421 head=HEAD
422 fi
423
424 cd_to_toplevel
425 # Get modified modules cared by user
426 modules=$(git diff-index $cached --raw $head -- "$@" |
Jeff King759ad192008-10-22 15:22:53 -0400427 egrep '^:([0-7]* )?160000' |
Ping Yin28f9af52008-03-11 21:52:15 +0800428 while read mod_src mod_dst sha1_src sha1_dst status name
429 do
430 # Always show modules deleted or type-changed (blob<->module)
431 test $status = D -o $status = T && echo "$name" && continue
432 # Also show added or modified modules which are checked out
433 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
434 echo "$name"
435 done
436 )
Ping Yin1cb639e2008-03-11 21:52:16 +0800437
Ping Yind0f64dd2008-04-12 23:05:31 +0800438 test -z "$modules" && return
439
Ping Yin1cb639e2008-03-11 21:52:16 +0800440 git diff-index $cached --raw $head -- $modules |
Jeff King759ad192008-10-22 15:22:53 -0400441 egrep '^:([0-7]* )?160000' |
Ping Yin1cb639e2008-03-11 21:52:16 +0800442 cut -c2- |
443 while read mod_src mod_dst sha1_src sha1_dst status name
444 do
445 if test -z "$cached" &&
446 test $sha1_dst = 0000000000000000000000000000000000000000
447 then
448 case "$mod_dst" in
449 160000)
450 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
451 ;;
452 100644 | 100755 | 120000)
453 sha1_dst=$(git hash-object $name)
454 ;;
455 000000)
456 ;; # removed
457 *)
458 # unexpected type
459 echo >&2 "unexpected mode $mod_dst"
460 continue ;;
461 esac
462 fi
463 missing_src=
464 missing_dst=
465
466 test $mod_src = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100467 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800468 missing_src=t
469
470 test $mod_dst = 160000 &&
Miklos Vajna30353a42008-12-03 14:26:52 +0100471 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
Ping Yin1cb639e2008-03-11 21:52:16 +0800472 missing_dst=t
473
474 total_commits=
475 case "$missing_src,$missing_dst" in
476 t,)
477 errmsg=" Warn: $name doesn't contain commit $sha1_src"
478 ;;
479 ,t)
480 errmsg=" Warn: $name doesn't contain commit $sha1_dst"
481 ;;
482 t,t)
483 errmsg=" Warn: $name doesn't contain commits $sha1_src and $sha1_dst"
484 ;;
485 *)
486 errmsg=
487 total_commits=$(
488 if test $mod_src = 160000 -a $mod_dst = 160000
489 then
490 range="$sha1_src...$sha1_dst"
491 elif test $mod_src = 160000
492 then
493 range=$sha1_src
494 else
495 range=$sha1_dst
496 fi
497 GIT_DIR="$name/.git" \
498 git log --pretty=oneline --first-parent $range | wc -l
499 )
Johannes Sixteed35592008-03-12 09:30:01 +0100500 total_commits=" ($(($total_commits + 0)))"
Ping Yin1cb639e2008-03-11 21:52:16 +0800501 ;;
502 esac
503
504 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
505 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
506 if test $status = T
507 then
508 if test $mod_dst = 160000
509 then
510 echo "* $name $sha1_abbr_src(blob)->$sha1_abbr_dst(submodule)$total_commits:"
511 else
512 echo "* $name $sha1_abbr_src(submodule)->$sha1_abbr_dst(blob)$total_commits:"
513 fi
514 else
515 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
516 fi
517 if test -n "$errmsg"
518 then
519 # Don't give error msg for modification whose dst is not submodule
520 # i.e. deleted or changed to blob
521 test $mod_dst = 160000 && echo "$errmsg"
522 else
523 if test $mod_src = 160000 -a $mod_dst = 160000
524 then
Ping Yinf2dc06a2008-03-11 21:52:17 +0800525 limit=
526 test $summary_limit -gt 0 && limit="-$summary_limit"
Ping Yin1cb639e2008-03-11 21:52:16 +0800527 GIT_DIR="$name/.git" \
Ping Yinf2dc06a2008-03-11 21:52:17 +0800528 git log $limit --pretty='format: %m %s' \
Ping Yin1cb639e2008-03-11 21:52:16 +0800529 --first-parent $sha1_src...$sha1_dst
530 elif test $mod_dst = 160000
531 then
532 GIT_DIR="$name/.git" \
533 git log --pretty='format: > %s' -1 $sha1_dst
534 else
535 GIT_DIR="$name/.git" \
536 git log --pretty='format: < %s' -1 $sha1_src
537 fi
538 echo
539 fi
540 echo
Ping Yind0f64dd2008-04-12 23:05:31 +0800541 done |
542 if test -n "$for_status"; then
543 echo "# Modified submodules:"
544 echo "#"
545 sed -e 's|^|# |' -e 's|^# $|#|'
546 else
547 cat
548 fi
Ping Yin28f9af52008-03-11 21:52:15 +0800549}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200550#
Lars Hjemli941987a2007-06-11 21:12:24 +0200551# List all submodules, prefixed with:
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200552# - submodule not initialized
553# + different revision checked out
554#
555# If --cached was specified the revision in the index will be printed
556# instead of the currently checked out revision.
557#
558# $@ = requested paths (default to all)
559#
Junio C Hamano23a485e2008-01-15 02:35:49 -0800560cmd_status()
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200561{
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800562 # parse $args after "submodule ... status".
563 while test $# -ne 0
564 do
565 case "$1" in
566 -q|--quiet)
567 quiet=1
568 ;;
569 --cached)
570 cached=1
571 ;;
572 --)
573 shift
574 break
575 ;;
576 -*)
577 usage
578 ;;
579 *)
580 break
581 ;;
582 esac
583 shift
584 done
585
David Aguilara7b32692008-08-22 00:30:50 -0700586 module_list "$@" |
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200587 while read mode sha1 stage path
588 do
Lars Hjemli941987a2007-06-11 21:12:24 +0200589 name=$(module_name "$path") || exit
Junio C Hamano5be60072007-07-02 22:52:14 -0700590 url=$(git config submodule."$name".url)
Lars Hjemliba88a1f2008-02-20 23:13:15 +0100591 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200592 then
593 say "-$sha1 $path"
594 continue;
595 fi
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200596 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200597 if git diff-files --quiet -- "$path"
598 then
Emil Medvebffe71f2007-06-26 18:40:58 -0500599 say " $sha1 $path$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200600 else
601 if test -z "$cached"
602 then
H.Merijn Brand51884082007-12-04 22:45:16 +0000603 sha1=$(unset GIT_DIR; cd "$path" && git rev-parse --verify HEAD)
CJ van den Berg41c7c1b2007-07-04 18:22:14 +0200604 set_name_rev "$path" "$sha1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200605 fi
Emil Medvebffe71f2007-06-26 18:40:58 -0500606 say "+$sha1 $path$revname"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200607 fi
608 done
609}
David Aguilar2327f612008-08-24 12:43:37 -0700610#
611# Sync remote urls for submodules
612# This makes the value for remote.$remote.url match the value
613# specified in .gitmodules.
614#
615cmd_sync()
616{
617 while test $# -ne 0
618 do
619 case "$1" in
620 -q|--quiet)
621 quiet=1
622 shift
623 ;;
624 --)
625 shift
626 break
627 ;;
628 -*)
629 usage
630 ;;
631 *)
632 break
633 ;;
634 esac
635 done
636 cd_to_toplevel
637 module_list "$@" |
638 while read mode sha1 stage path
639 do
640 name=$(module_name "$path")
641 url=$(git config -f .gitmodules --get submodule."$name".url)
Johan Herlandbaede9f2008-09-22 18:08:31 +0200642
643 # Possibly a url relative to parent
644 case "$url" in
645 ./*|../*)
646 url=$(resolve_relative_url "$url") || exit
647 ;;
648 esac
649
David Aguilar2327f612008-08-24 12:43:37 -0700650 if test -e "$path"/.git
651 then
652 (
653 unset GIT_DIR
654 cd "$path"
655 remote=$(get_default_remote)
656 say "Synchronizing submodule url for '$name'"
657 git config remote."$remote".url "$url"
658 )
659 fi
660 done
661}
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200662
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800663# This loop parses the command line arguments to find the
664# subcommand name to dispatch. Parsing of the subcommand specific
665# options are primarily done by the subcommand implementations.
666# Subcommand specific options such as --branch and --cached are
667# parsed here as well, for backward compatibility.
668
669while test $# != 0 && test -z "$command"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200670do
671 case "$1" in
David Aguilar2327f612008-08-24 12:43:37 -0700672 add | foreach | init | update | status | summary | sync)
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800673 command=$1
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200674 ;;
675 -q|--quiet)
676 quiet=1
677 ;;
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200678 -b|--branch)
679 case "$2" in
680 '')
681 usage
682 ;;
683 esac
684 branch="$2"; shift
685 ;;
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200686 --cached)
Ping Yin28f9af52008-03-11 21:52:15 +0800687 cached="$1"
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200688 ;;
689 --)
690 break
691 ;;
692 -*)
693 usage
694 ;;
695 *)
696 break
697 ;;
698 esac
699 shift
700done
701
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800702# No command word defaults to "status"
703test -n "$command" || command=status
Sven Verdoolaegeecda0722007-06-24 23:06:07 +0200704
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800705# "-b branch" is accepted only by "add"
706if test -n "$branch" && test "$command" != add
707then
Lars Hjemli70c7ac22007-05-26 15:56:40 +0200708 usage
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800709fi
710
Ping Yin28f9af52008-03-11 21:52:15 +0800711# "--cached" is accepted only by "status" and "summary"
712if test -n "$cached" && test "$command" != status -a "$command" != summary
Junio C Hamano5c08dbb2008-01-15 02:48:45 -0800713then
714 usage
715fi
716
717"cmd_$command" "$@"